Encoding: UTF-8
Package: getopt
Type: Package
Title: C-Like 'getopt' Behavior
Version: 1.20.4
Authors@R: c(person("Trevor L", "Davis", role=c("aut", "cre"),
             email="trevor.l.davis@gmail.com",
             comment = c(ORCID = "0000-0001-6341-4639")),
    person("Allen", "Day", role="aut", comment="Original package author"),
    person("Roman", "Zenka", role="ctb"))
URL: https://github.com/trevorld/r-getopt
Imports: stats
BugReports: https://github.com/trevorld/r-getopt/issues
Description: Package designed to be used with Rscript to write
    '#!' shebang scripts that accept short and long flags/options.
    Many users will prefer using instead the packages optparse or argparse
    which add extra features like automatically generated help option and usage,
    support for default values, positional argument support, etc.
License: GPL (>= 2)
Suggests: testthat
RoxygenNote: 7.2.3
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2023-10-01 05:01:35 UTC; trevorld
Author: Trevor L Davis [aut, cre] (<https://orcid.org/0000-0001-6341-4639>),
  Allen Day [aut] (Original package author),
  Roman Zenka [ctb]
Maintainer: Trevor L Davis <trevor.l.davis@gmail.com>
Repository: CRAN
Date/Publication: 2023-10-01 06:30:01 UTC
Built: R 4.4.0; ; 2026-07-18 01:09:36 UTC; unix

Encoding: UTF-8
Package: getopt
Type: Package
Title: C-Like 'getopt' Behavior
Version: 1.21.1
Authors@R: c(person("Trevor L.", "Davis", role=c("aut", "cre"),
             email="trevor.l.davis@gmail.com",
             comment = c(ORCID = "0000-0001-6341-4639")),
    person("Allen", "Day", role="aut", comment="Original package author"),
    person("Roman", "Zenka", role="ctb"))
URL: https://github.com/trevorld/r-getopt,
        https://trevorldavis.com/R/getopt/
BugReports: https://github.com/trevorld/r-getopt/issues
Description: Package designed to be used with Rscript to write
    '#!' shebang scripts that accept short and long flags/options.
    Many users will prefer using instead the packages optparse or argparse
    which add extra features like automatically generated help option and usage,
    support for default values, positional argument support, etc.
License: GPL (>= 2)
Depends: R (>= 3.3)
Suggests: stats, testthat
RoxygenNote: 7.3.3
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-04-27 18:17:27 UTC; trevorld
Author: Trevor L. Davis [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6341-4639>),
  Allen Day [aut] (Original package author),
  Roman Zenka [ctb]
Maintainer: Trevor L. Davis <trevor.l.davis@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-27 18:50:02 UTC
Built: R 4.6.0; ; 2026-04-27 21:35:35 UTC; unix

NAME
    getopt - Shortcut for using Getopt::Std's getopt() from the command line

VERSION
    This document describes version 0.001 of getopt (from Perl distribution
    getopt), released on 2020-04-08.

SYNOPSIS
     % perl -Mgetopt=oDI -e '...'

    is shortcut for:

     % perl -MGetopt::Std -e 'getopt("oDI"); ...'

DESCRIPTION
HOMEPAGE
    Please visit the project's homepage at
    <https://metacpan.org/release/getopt>.

SOURCE
    Source repository is at <https://github.com/perlancar/perl-getopt>.

BUGS
    Please report any bugs or feature requests on the bugtracker website
    <https://rt.cpan.org/Public/Dist/Display.html?Name=getopt>

    When submitting a bug or request, please include a test-file or a patch
    to an existing test-file that illustrates the bug or desired feature.

SEE ALSO
    Getopt::Std

    getopts

    perl's "-s" switch

AUTHOR
    perlancar <perlancar@cpan.org>

COPYRIGHT AND LICENSE
    This software is copyright (c) 2020 by perlancar@cpan.org.

    This is free software; you can redistribute it and/or modify it under
    the same terms as the Perl 5 programming language system itself.

getopt
======

[![CRAN Status Badge](https://www.r-pkg.org/badges/version/getopt)](https://cran.r-project.org/package=getopt) [![R-CMD-check](https://github.com/trevorld/r-getopt/actions/workflows/R-CMD-check.yaml/badge.svg?branch=master)](https://github.com/trevorld/r-getopt/actions) [![Coverage Status](https://codecov.io/github/trevorld/r-getopt/branch/master/graph/badge.svg)](https://app.codecov.io/github/trevorld/r-getopt?branch=master) [![RStudio CRAN mirror downloads](https://cranlogs.r-pkg.org/badges/getopt)](https://cran.r-project.org/package=getopt) [![Number of dependencies](https://tinyverse.netlify.app/badge/getopt)](https://cran.r-project.org/package=getopt)

<img src="man/figures/logo.png" align="right" width="200px" alt="optparse hex sticker">

`getopt` is an R package designed to be used with `Rscript` to write
"\#!"-shebang scripts that accept short and long flags/options. Many
users will prefer using instead the package
[optparse](https://github.com/trevorld/r-optparse) which adds extra
features (automatically generated help option and usage, support for
default values, basic positional argument support).

To install the last version released on CRAN use the following command:

    install.packages("getopt")

To install the development version use the following command:

    install.packages("remotes")
    remotes:install_github("trevorld/r-getopt")

example
-------

An example Rscript using `getopt` with R 4.4+ (i.e. support for `%||%`
and `|>`):

    #!/path/to/Rscript
    library('getopt')
    # get options, using the spec as defined by the matrix
    # fmt: skip
    spec <- matrix(c(
      'verbose', 'v', 2, "integer",
      'help'   , 'h', 0, "logical",
      'count'  , 'c', 1, "integer",
      'mean'   , 'm', 1, "double",
      'sd'     , 's', 1, "double"
    ), byrow = TRUE, ncol = 4L)
    opt <- getopt(spec)

    # if help was asked for print a friendly message and exit
    if (isTRUE(opt$help)) {
      getusage(spec) |> cat()
      quit(status = 0)
    }

    # set reasonable defaults for options that were not specified
    opt$mean <- opt$mean %||% 0
    opt$sd <- opt$sd %||% 1
    opt$count <- opt$count %||% 10L
    opt$verbose <- opt$verbose %||% FALSE

    # print some progress messages to stderr, if requested
    if (opt$verbose) write("writing...", stderr())

    # do some operation based on user input
    rnorm(opt$count, mean = opt$mean, sd = opt$sd) |> cat(sep="\n")

An example Rscript using `getopt` for old versions of R:

    #!/path/to/Rscript
    library('getopt')
    # get options, using the spec as defined by the matrix
    spec <- matrix(c(
      'verbose', 'v', 2, "integer",
      'help'   , 'h', 0, "logical",
      'count'  , 'c', 1, "integer",
      'mean'   , 'm', 1, "double",
      'sd'     , 's', 1, "double"
    ), byrow = TRUE, ncol = 4L)
    opt <- getopt(spec)

    # if help was asked for print a friendly message and exit
    if (!is.null(opt$help)) {
      cat(getusage(spec))
      quit(status = 0)
    }

    # set reasonable defaults for options that were not specified
    if (is.null(opt$mean)) opt$mean <- 0
    if (is.null(opt$sd)) opt$sd <- 1
    if (is.null(opt$count)) opt$count <- 10L
    if (is.null(opt$verbose)) opt$verbose <- FALSE

    # print some progress messages to stderr, if requested
    if (opt$verbose) write("writing...", stderr())

    # do some operation based on user input
    cat(rnorm(opt$count, mean = opt$mean, sd = opt$sd), sep = "\n")

#!/usr/local/bin/Rscript
library('getopt')
library('stats')
#get options, using the spec as defined by the enclosed list.
#we read the options from the default: commandArgs(TRUE).
spec = matrix(c(
  'verbose', 'v', 2, "integer",
  'help'   , 'h', 0, "logical",
  'count'  , 'c', 1, "integer",
  'mean'   , 'm', 1, "double",
  'sd'     , 's', 1, "double"
), byrow=TRUE, ncol=4)
opt = getopt(spec)

# if help was asked for print a friendly message 
# and exit with a non-zero error code
if ( !is.null(opt$help) ) {
  cat(getopt(spec, usage=TRUE))
  q(status=1)
}

#set some reasonable defaults for the options that are needed,
#but were not specified.
if ( is.null(opt$mean    ) ) { opt$mean    = 0     }
if ( is.null(opt$sd      ) ) { opt$sd      = 1     }
if ( is.null(opt$count   ) ) { opt$count   = 10    }
if ( is.null(opt$verbose ) ) { opt$verbose = FALSE }

#print some progress messages to stderr, if requested.
if ( opt$verbose ) { write("writing...",stderr()) }

#do some operation based on user input.
cat(paste(rnorm(opt$count,mean=opt$mean,sd=opt$sd),collapse="\n"))
cat("\n")

#signal success and exit.
q(status=0)

#!/path/to/Rscript
library('getopt')
library('stats')
#get options, using the spec as defined by the enclosed list.
#we read the options from the default: commandArgs(TRUE).
spec = matrix(
	c(
		'verbose',
		'v',
		2,
		"integer",
		'help',
		'h',
		0,
		"logical",
		'count',
		'c',
		1,
		"integer",
		'mean',
		'm',
		1,
		"double",
		'sd',
		's',
		1,
		"double"
	),
	byrow = TRUE,
	ncol = 4
)
opt = getopt(spec)

# if help was asked for print a friendly message
# and exit with a non-zero error code
if (!is.null(opt$help)) {
	cat(getopt(spec, usage = TRUE))
	q(status = 1)
}

#set some reasonable defaults for the options that are needed,
#but were not specified.
if (is.null(opt$mean)) {
	opt$mean = 0
}
if (is.null(opt$sd)) {
	opt$sd = 1
}
if (is.null(opt$count)) {
	opt$count = 10
}
if (is.null(opt$verbose)) {
	opt$verbose = FALSE
}

#print some progress messages to stderr, if requested.
if (opt$verbose) {
	write("writing...", stderr())
}

#do some operation based on user input.
cat(paste(rnorm(opt$count, mean = opt$mean, sd = opt$sd), collapse = "\n"))
cat("\n")

#signal success and exit.
q(status = 0)

#!/usr/bin/env Rscript
# Copyright 2010-2026 Trevor L Davis <trevor.l.davis@gmail.com>
# Copyright 2013 Kirill Müller
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
library("getopt")
options(error = function(e) quit("no", status = 1, runLast = FALSE))

# fmt: skip
spec <- matrix(c(
	"add_numbers", "n", "store_true", "logical", "Print line number at the beginning of each line",
	"help", "h", "store_true", "logical", "Print usage message"
), ncol = 5L, byrow = TRUE)

opt <- getopt(spec, operand = "strict")

if (!is.null(opt$help)) {
	cat(getusage(spec, usage = "Usage: %command %options FILE"))
	quit(status = 1)
}

file <- getoperand(opt)
if (is.null(file) || length(file) != 1L) {
	stop("You must pass in a single positional argument of a file")
}

if (!file.exists(file)) {
	stop(sprintf("Specified file `%s` does not exist", file))
}

file_text <- readLines(file)

if (isTRUE(opt$add_numbers)) {
	cat(paste(seq_along(file_text), file_text), sep = "\n")
} else {
	cat(file_text, sep = "\n")
}

# Copyright (c) 2011-2026 Trevor L. Davis <trevor.l.davis@gmail.com>
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#' Returns file name being interpreted by Rscript
#'
#' `getfile()` returns the file name that `Rscript` is interpreting.
#' Also supports `littler` via the `LITTLER_SCRIPT_PATH` environment variable.
#' `get_Rscript_filename()` is an alias.
#' @return A string with the filename of the calling script.
#'      If not found (i.e. you are in a interactive session) returns `NA_character_`.
#' @export
getfile <- function() {
	args <- command_args()
	args_idx <- match("--args", args)
	if (!is.na(args_idx)) {
		args <- args[seq_len(args_idx - 1L)]
	}
	prog <- sub("--file=", "", grep("^--file=", args, value = TRUE)[1L])
	if (is.na(prog)) {
		prog <- littler_script_path()
	}
	if (!is.na(prog) && .Platform$OS.type == "windows") {
		prog <- gsub("\\\\", "\\\\\\\\", prog)
	}
	prog
}

#' @rdname getfile
#' @export
get_Rscript_filename <- getfile

command_args <- function() commandArgs()

littler_script_path <- function() Sys.getenv("LITTLER_SCRIPT_PATH", unset = NA_character_)

is_negative_number <- function(x) {
	regexpr("^-[0-9]*\\.?[0-9]+([eE][-+]?[0-9]+)?$", x) > 0L
}

is_long_flag <- function(x) {
	startsWith(x, "--") && nchar(x) > 2L
}

is_short_flag <- function(x) {
	startsWith(x, "-") && !startsWith(x, "--") && nchar(x) == 2L
}

is_bundle <- function(o) {
	startsWith(o, "-") && !startsWith(o, "--") && nchar(o) > 2L
}

expand_bundle <- function(o) {
	paste0("-", strsplit(substring(o, 2L), "")[[1L]])
}

prev_takes_argument <- function(prev, spec) {
	if (is_long_flag(prev) && !grepl("=", prev, fixed = TRUE)) {
		rowmatch <- tryCatch(get_rowmatch(spec, long = substring(prev, 3L)), error = function(e) {
			NA_integer_
		})
	} else if (is_short_flag(prev)) {
		rowmatch <- tryCatch(get_rowmatch(spec, short = substring(prev, 2L)), error = function(e) {
			NA_integer_
		})
	} else {
		return(FALSE)
	}
	actions <- c("append", "store", "store_optional")
	!is.na(rowmatch) && spec[rowmatch, COL_ACTION] %in% actions
}

normalize_opt <- function(opt, spec) {
	result <- character(0L)
	for (o in opt) {
		if (!is_bundle(o)) {
			result <- c(result, o)
		} else if (!is_negative_number(o)) {
			result <- c(result, expand_bundle(o))
		} else if (length(result) > 0L && prev_takes_argument(result[length(result)], spec)) {
			result <- c(result, o)
		} else {
			result <- c(result, expand_bundle(o))
		}
	}
	result
}

`%||%` <- function(x, y) if (is.null(x)) y else x

get_rowmatch <- function(spec, long = NULL, short = NULL) {
	if (!is.null(long)) {
		rowmatch <- grep(long, spec[, COL_LONG_NAME], fixed = TRUE)
		if (length(rowmatch) == 0L) {
			stop(paste0('long flag "', long, '" is invalid'))
		} else if (length(rowmatch) > 1L) {
			rowmatch <- which(long == spec[, COL_LONG_NAME])
			if (length(rowmatch) == 0L) {
				stop(paste0('long flag "', long, '" is ambiguous'))
			}
		}
	} else {
		rowmatch <- grep(short, spec[, COL_SHORT_NAME], fixed = TRUE)
		if (length(rowmatch) == 0L) {
			stop(paste0('short flag "', short, '" is invalid'))
		}
	}
	rowmatch
}

na_omit <- function(x) {
	Filter(Negate(is.na), x)
}

#' Recursively sorts a list
#'
#' `sort_list()` returns a recursively sorted list
#' @param unsorted_list A list.
#' @return A sorted list.
#' @examples
#' l <- list(b = 2, a = 1)
#' sort_list(l)
#' @export
sort_list <- function(unsorted_list) {
	for (ii in seq_along(unsorted_list)) {
		if (is.list(unsorted_list[[ii]])) {
			unsorted_list[[ii]] <- sort_list(unsorted_list[[ii]])
		}
	}
	unsorted_list[sort(names(unsorted_list))]
}

test_that("getopt works as expected", {
    spec <- matrix(c(
      "verbose", "v", 2, "integer",
      "help", "h", 0, "logical",
      "dummy1", "d", 0, "logical",
      "dummy2", "e", 2, "logical",
      "count", "c", 1, "integer",
      "mean", "m", 1, "double",
      "sd", "s", 1, "double",
      "output", "O", 1, "character"
    ), ncol = 4, byrow = TRUE)
    expect_equal(sort_list(getopt(spec, c("-c", "-1", "-m", "-1.2"))),
                    sort_list(list(ARGS = character(0), count = -1, mean = -1.2)))
    expect_equal(sort_list(getopt(spec, c("-v", "-m", "3"))),
                    sort_list(list(ARGS = character(0), verbose = 1, mean = 3)))
    expect_equal(sort_list(getopt(spec, c("-m", "3", "-v"))),
            sort_list(list(ARGS = character(0), mean = 3, verbose = 1)))
    expect_equal(sort_list(getopt(spec, c("-m", "3", "-v", "2", "-v"))),
            sort_list(list(ARGS = character(0), mean = 3, verbose = 1)))
    expect_equal(sort_list(getopt(spec, c("-O", "-", "-m", "3"))),
            sort_list(list(ARGS = character(0), output = "-", mean = 3)))
    expect_equal(sort_list(getopt(spec, c("-O", "-", "-m", "3"))),
            sort_list(getopt(spec, c("-m", "3", "-O", "-"))))
    expect_equal(sort_list(getopt(spec, c("-de"))),
            sort_list(getopt(spec, c("-ed"))))
    expect_equal(sort_list(getopt(spec, c("-de"))),
            sort_list(list(ARGS = character(0), dummy1 = TRUE, dummy2 = TRUE)))
    expect_equal(sort_list(getopt(spec, c("-de", "1"))),
            sort_list(list(ARGS = character(0), dummy1 = TRUE, dummy2 = NA)))
    expect_equal(sort_list(getopt(spec, c("--verbose"))),
            sort_list(list(ARGS = character(0), verbose = 1)))
    expect_equal(sort_list(getopt(spec, c("--verbose", "--help"))),
            sort_list(list(ARGS = character(0), verbose = 1, help = TRUE)))
    expect_equal(sort_list(getopt(spec, c("--verbose", "--mean", "5"))),
            sort_list(list(ARGS = character(0), verbose = 1, mean = 5)))
    expect_equal(sort_list(getopt(spec, c("--mean=5"))),
            sort_list(list(ARGS = character(0), mean = 5)))
    expect_equal(sort_list(getopt(spec, c("--verbose", "--mean=5", "--sd", "5"))),
            sort_list(list(ARGS = character(0), verbose = 1, mean = 5, sd = 5)))
    expect_equal(sort_list(getopt(spec, c("--verbose", "--mean=5", "--sd", "5"))),
            sort_list(getopt(spec, c("--mean=5", "--sd", "5", "--verbose"))))

    spec <- c(
      "date", "d", 1, "character",
      "help", "h", 0, "logical",
      "getdata", "g", 0, "logical",
      "market", "m", 1, "character",
      "threshold", "t", 1, "double"
    )
    spec2 <- matrix(spec, ncol = 4, byrow = TRUE)
    # should give warning is spec is not matrix
    expect_warning(getopt(spec, c("--date", "20080421", "--market", "YM", "--getdata")))
    expect_equal(sort_list(getopt(spec2, c("--date", "20080421", "--market", "YM", "--getdata"))),
            sort_list(list(ARGS = character(0), date = "20080421", market = "YM", getdata = TRUE)))
    expect_equal(sort_list(getopt(spec2, c("--date", "20080421", "--market", "YM", "--getdata"))),
            sort_list(getopt(spec2, c("--date", "20080421", "--getdata", "--market", "YM"))))
    expect_output(getopt(spec2, c("--date", "20080421", "--getdata", "--market", "YM"), debug = TRUE),
            "processing ")
    expect_output(print(getopt(spec2, c("--date", "20080421", "--getdata", "--market", "YM"), usage = TRUE)),
            "Usage: ")
})
test_that("numeric is cast to double", {
    # Feature reported upstream (optparse) by Miroslav Posta
    spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
    opt <- getopt(spec, c("-c", "-55"))
    expect_equal(typeof(opt$count), "integer")


    spec <- matrix(c("count", "c", 1, "numeric"), ncol = 4, byrow = TRUE)
    opt <- getopt(spec, c("-c", "-55.0"))
    expect_equal(typeof(opt$count), "double")
})
test_that("empty strings are handled correctly for mandatory character arguments", {
    spec <- matrix(c("string", "s", 1, "character",
                    "number", "n", 1, "numeric"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("--string=foo"))$string, "foo")
    expect_equal(getopt(spec, c("--string="))$string, "")
    expect_warning(getopt(spec, c("--number=")))

})

test_that("negative numbers are handled correctly", {
    # Issue if negative number preceded by space instead of '=' reported by Roman Zenka
    spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("-c", "5"))$count, 5)
    spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("-c", "-5"))$count, -5)
    spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("--count=-1E5"))$count, -1E5)
    spec <- matrix(c("count", "c", 1, "double"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("-c", "-5"))$count, -5)
    spec <- matrix(c("count", "c", 1, "double"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("-c", "-1e5"))$count, -1e5)
    spec <- matrix(c("count", "c", 1, "double"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("--count=-1.2e5"))$count, -1.2e5)
    spec <- matrix(c("count", "c", 1, "double"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("--count", "-1e5"))$count, -1e5)
})

test_that("more helpful warnings upon incorrect input", {
    # Give more pointed warning upon wildly incorrect input
    spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
    expect_warning(getopt(spec, c("-c", "hello"))$count, paste("integer expected, got", dQuote("hello")))

    spec <- NULL
    expect_error(getopt(spec, ""), 'argument "spec" must be non-null.')

    spec <- c("foo", "f", 0)
    expect_error(getopt(spec, ""), "or a character vector with length divisible by 4, rtfm")

    spec <- matrix(c("foo", "f", 0, "integer"), ncol = 2)
    expect_error(getopt(spec, ""), '"spec" should have at least 4 columns.')

    spec <- matrix(c("foo", "f", 0, "integer", "bar", "b", 0, "integer"), ncol = 8)
    expect_error(getopt(spec, ""), '"spec" should have no more than 6 columns.')
})

test_that("don't throw error if multiple matches match one argument fully", {
    # test if partial name matches fully,
    # still throw error if multiple matches and doesn't match both fully
    # feature request from Jonas Zimmermann
    spec <- matrix(c(
      "foo", "f", 0, "logical",
      "foobar", "b", 0, "logical",
      "biz", "z", 0, "logical"
      ), ncol = 4, byrow = TRUE)
    expect_error(getopt(spec, c("--fo")))
    expect_equal(getopt(spec, c("--foo")), sort_list(list(ARGS = character(0), foo = TRUE)))
})

test_that("sort_list works as expected", {
    expect_equal(sort_list(list(a = 3, b = 2)), sort_list(list(b = 2, a = 3)))
    expect_false(identical(sort_list(list(b = 3, a = 2)), list(b = 3, a = 2)))
    expect_false(identical(sort_list(list(b = list(b = 3, c = 2), a = 2)),
                           list(b = list(c = 2, b = 3), a = 2)))
})

test_that("Use h flag for non help", {
    spec <- matrix(c("foo", "h", 0, "logical"), ncol = 4, byrow = TRUE)
    expect_equal(getopt(spec, c("-h")), sort_list(list(ARGS = character(0), foo = TRUE)))

    spec <- matrix(c("foo", "h", 0, "logical",
                   "help", "h", 0, "logical"), ncol = 4, byrow = TRUE)
    expect_error(getopt(spec, c("-h")), "redundant short names for flags")

    spec <- matrix(c("foo", "f", 0, "logical",
                   "foo", "h", 0, "logical"), ncol = 4, byrow = TRUE)
    expect_error(getopt(spec, c("-h")), "redundant long names for flags")
})

test_that("Optional usage strings work as expected", {
    spec <- matrix(c(
      "foo", "f", 0, "logical", "foo usage",
      "foobar", "b", 1, "character", "foobar usage",
      "biz", "z", 2, "logical", "biz usage",
      "number", "n", 1, "numeric", "number usage",
      "help", "h", 0, "logical", "help"
      ), ncol = 5, byrow = TRUE)
    expect_output(cat(getopt(spec, usage = TRUE)), "foobar usage")
})

test_that("tests to get coverage up", {
    spec <- matrix(c(
      "foo", "f", 0, "logical", "foo usage",
      "foobar", "b", 1, "character", "foobar usage",
      "biz", "z", 2, "logical", "biz usage",
      "number", "n", 1, "numeric", "number usage",
      "help", "h", 0, "logical", "help"
      ), ncol = 5, byrow = TRUE)
    expect_error(getopt(spec, "--whodunit"), 'long flag "whodunit" is invalid')

    expect_error(getopt(spec, "--foo=4"), 'long flag "foo" accepts no arguments')

    # expect_error(getopt(spec, c("--foo", "4")), 'long flag "foo" accepts no arguments') # nolint

    expect_equal(getopt(spec, "--biz", "4"), sort_list(list(ARGS = character(0), biz = TRUE)))

    expect_warning(getopt(spec, c("-n", "bar")), paste("double expected, got", dQuote("bar")))

    expect_warning(getopt(spec, c("--number=bar")), paste("double expected, got", dQuote("bar")))

    expect_error(getopt(spec, "-n"), 'flag "n" requires an argument')

    expect_error(getopt(spec, "-p"), 'short flag "p" is invalid')

    expect_error(getopt(spec, "-nh"), 'short flag "n" requires an argument, but has none')
    expect_error(getopt(spec, "-fn"), 'flag "n" requires an argument')

    expect_error(getopt(spec, c("--number", 3, 4)), '"4" is not a valid option, or does not support an argument')
    expect_error(getopt(spec, c("-b")), '"b" requires an argument')
    expect_error(getopt(spec, c("--foobar")), 'flag "foobar" requires an argument')
    expect_error(getopt(spec, c("--foobar", "--help")), 'flag "foobar" requires an argument')

    expect_output(getopt(spec, c("-n", "2"), debug = TRUE), "short option: -n")
    expect_output(getopt(spec, c("-b", "-"), debug = TRUE), "lone dash")
    expect_warning(getopt(spec, c("-n", "-")), paste("double expected, got",  dQuote("-")))
})

test_that("is_long_flag() identifies long flags", {
	expect_true(is_long_flag("--verbose"))
	expect_false(is_long_flag("--"))
	expect_false(is_long_flag("-v"))
	expect_false(is_long_flag("foo"))
})

test_that("is_short_flag() identifies short flags", {
	expect_true(is_short_flag("-v"))
	expect_true(is_short_flag("-3"))
	expect_false(is_short_flag("--verbose"))
	expect_false(is_short_flag("-3.14"))
	expect_false(is_short_flag("foo"))
})

test_that("normalize_opt() splits short flag clusters", {
	# fmt: skip
	spec <- as_spec(matrix(c(
		"s"      , "s", 0, "logical",
		"b"      , "b", 0, "logical",
		"g"      , "g", 0, "logical",
		"verbose", "v", 0, "logical"
	), ncol = 4, byrow = TRUE))
	expect_equal(normalize_opt(c("-sbg", "--verbose"), spec), c("-s", "-b", "-g", "--verbose"))
})

test_that("normalize_opt() treats negative-number-like bundles as arguments when preceding flag takes an argument", {
	# fmt: skip
	spec <- as_spec(matrix(c(
		"mean"   , "m", "store", "double",
		"verbose", "v", "store_true", "logical"
	), ncol = 4, byrow = TRUE))
	expect_equal(normalize_opt(c("-m", "-3.14"), spec), c("-m", "-3.14"))
	expect_equal(normalize_opt(c("--mean", "-1e5"), spec), c("--mean", "-1e5"))
	expect_equal(normalize_opt(c("-v", "-1e5"), spec), c("-v", "-1", "-e", "-5"))
	expect_equal(normalize_opt(c("-1e5"), spec), c("-1", "-e", "-5"))
})

test_that("get_Rscript_filename() ignores --file= after --args", {
	local_mocked_bindings(
		command_args = function() c("Rscript", "--file=script.R", "--args", "--file=fake.R")
	)
	expect_equal(get_Rscript_filename(), "script.R")
})

test_that("get_Rscript_filename() works with no --args", {
	local_mocked_bindings(
		command_args = function() c("Rscript", "--file=script.R")
	)
	expect_equal(get_Rscript_filename(), "script.R")
})

test_that("get_Rscript_filename() returns NA when no --file=", {
	local_mocked_bindings(
		command_args = function() character(0)
	)
	expect_equal(get_Rscript_filename(), NA_character_)
})

test_that("get_Rscript_filename() returns NA when no --file= before --args", {
	local_mocked_bindings(
		command_args = function() c("R", "--args", "--file=boo.r")
	)
	expect_equal(get_Rscript_filename(), NA_character_)
})

test_that("getfile() returns LITTLER_SCRIPT_PATH when set", {
	local_mocked_bindings(
		littler_script_path = function() "script.r"
	)
	expect_equal(getfile(), "script.r")
})

# Copyright (c) 2008-2010 Allen Day
# Copyright (c) 2011-2018 Trevor L. Davis <trevor.l.davis@gmail.com>
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#' C-like getopt behavior
#'
#' `getopt` is primarily intended to be used with `Rscript`.  It
#' facilitates writing `#!` shebang scripts that accept short and long
#' flags/options.  It can also be used from `R` directly, but is probably less
#' useful in this context.
#'
#' Notes on naming convention:
#'
#' 1. An \emph{option} is one of the shell-split input strings.
#'
#' 2. A \emph{flag} is a type of \emph{option}.  a \emph{flag} can be defined as
#' having no \emph{argument} (defined below), a required \emph{argument}, or an
#' optional \emph{argument}.
#'
#' 3. An \emph{argument} is a type of \emph{option}, and is the value associated
#' with a flag.
#'
#' 4. A \emph{long flag} is a type of \emph{flag}, and begins with the string
#' `--`.  If the \emph{long flag} has an associated \emph{argument}, it may be
#' delimited from the \emph{long flag} by either a trailing `=`, or may be
#' the subsequent \emph{option}.
#'
#' 5. A \emph{short flag} is a type of \emph{flag}, and begins with the string
#' `-`.  If a \emph{short flag} has an associated \emph{argument}, it is the
#' subsequent \emph{option}.  \emph{short flags} may be bundled together,
#' sharing a single leading `-`, but only the final \emph{short flag} is able
#' to have a corresponding \emph{argument}.
#'
#' Many users wonder whether they should use the `getopt` package, `optparse` package,
#' or `argparse` package.
#' Here is some of the major differences:
#'
#' Features available in `getopt` unavailable in `optparse`
#'
#' 1. `getopt` allows one to specify options with an optional argument.
#'
#' 2. Long flags may be abbreviated as long as the abbreviation is unique,
#' e.g. `--verb` matches `--verbose` if no other long flag starts with `verb`.
#'
#' Some features implemented in the `optparse` package unavailable in `getopt`
#'
#' 1. Support for capturing positional arguments after the optional arguments
#' when `positional_arguments` set to `TRUE` in `optparse::parse_args()`
#'
#' 2. Automatic generation of an help option and printing of help text when encounters an `-h`
#'
#' 3. Option to specify default arguments for options as well the
#'    variable name to store option values
#'
#' There is also package `argparse` supports
#' all the features of both getopt and optparse (plus more)
#  but which has a dependency on Python 2.7 or 3.2+.
#'
#' Some Features unlikely to be implemented in `getopt`:
#'
#' 1. Support for lists, e.g. `--define os=linux --define os=redhat` would
#' set `result$os$linux=TRUE` and `result$os$redhat=TRUE`.
#'
#' @aliases getopt getopt-package
#' @param spec The getopt specification, or spec of what options are considered
#' valid.  The specification must be either a 4-5 column matrix, a 4-5 column data frame, or a
#' character vector coercible into a 4 column matrix using
#' `matrix(x, ncol = 4L, byrow = TRUE)` command.  The matrix/vector
#' contains:
#'
#' Column 1: the \emph{long flag} name.  A multi-character string.
#'
#' Column 2: \emph{short flag} alias of Column 1.  A single-character string.
#' May be `NA_character_` if there is no short flag.
#'
#' Column 3: \emph{Action} of the \emph{flag}.  A string.
#' Possible values:
#'
#' * `"append"` (flag takes a required argument; appends it to a vector each time the flag is used)
#' * `"count"` (flag takes no argument; stores count of how many times the flag was present)
#' * `"store_true"` (flag takes no argument; stores `TRUE`)
#' * `"store_false"` (flag takes no argument; stores `FALSE`)
#' * `"store"` (flag takes a required argument)
#' * `"store_optional"` (flag takes an optional argument but if none present stores `TRUE`)
#'
#' For backwards compatibility `0`, `1`, `2` are accepted as aliases for
#' `"store_true"`, `"store"`, `"store_optional"` respectively.
#'
#' Column 4: Data type to which the \emph{flag}'s argument shall be cast using
#' [storage.mode()].  A multi-character string.
#' Only used when an action took an argument.
#' Possible values: "logical", "integer", "double", "complex", "character".
#' "numeric" is treated as an alias for "double".
#'
#' Column 5 (optional): A brief description of the purpose of the option.
#'
#' The terms \emph{option}, \emph{flag}, \emph{long flag}, \emph{short flag},
#' and \emph{argument} have very specific meanings in the context of this
#' document.  Read the \dQuote{Details} section of [getopt()] for definitions.
#' @param opt This defaults to the return value of `commandArgs(TRUE)` unless
#'    `argv` is in the global environment in which case it uses that instead
#'    (this is for compatibility with `littler`).
#'
#' If R was invoked directly via the `R` command, this corresponds to all
#' arguments passed to R after the `--args` flag.
#'
#' If R was invoked via the `Rscript` command, this corresponds to all
#' arguments after the name of the R script file.
#'
#' Read about [commandArgs()] and \link{Rscript} to learn more.
#' @param command The string to use in the usage message as the name of the
#' script.  See argument \emph{usage}.
#' @param usage If `TRUE`, argument `opt` will be ignored and a usage
#' statement (character string) will be generated and returned from `spec`.
#' @param debug This is used internally to debug the `getopt()` function itself.
#' @param operand Controls how positional arguments (operands) are handled.
#'
#'   * `"after--only"` (the default) only collects operands that appear after a `"--"` separator.
#'   * `"strict"` (in addition to operands that appear after a `"--"` separator) collects tokens that do not look
#'     like flags and were not consumed as a flag argument, while still erroring on
#' unrecognized flags.
#'
#'   Operands are stored in the `"operand"` attribute of the
#' result and can be retrieved with [getoperand()].
#' @return [getopt()] returns a list data structure containing names of the
#'   flags that were present in the character vector passed in under
#'   the `opt` argument.  Each value of the list is coerced to the
#'   data type specified according to the value of the `spec` argument.  See
#'   the \dQuote{Details} section for more information.
#'   Any positional arguments (operands) are stored in its `"operand"` attribute
#'   and can also be accessed by [getoperand()].
#' @author Allen Day and Trevor L. Davis
#' @keywords data
#' @export
#' @examples
#' #!/path/to/Rscript
#' library('getopt')
#' # get options, using the spec as defined by the matrix
#' spec <- matrix(c(
#'   'verbose', 'v', 2, "integer",
#'   'help'   , 'h', 0, "logical",
#'   'count'  , 'c', 1, "integer",
#'   'mean'   , 'm', 1, "double",
#'   'sd'     , 's', 1, "double"
#' ), byrow = TRUE, ncol = 4L)
#' opt <- getopt(spec)
#'
#' # if help was asked for print a friendly message and exit
#' if (isTRUE(opt$help)) {
#'   cat(getusage(spec))
#'   q(status = 0)
#' }
#'
#' # set reasonable defaults for options that were not specified
#' if (is.null(opt$mean)) opt$mean <- 0
#' if (is.null(opt$sd)) opt$sd <- 1
#' if (is.null(opt$count)) opt$count <- 10L
#' if (is.null(opt$verbose)) opt$verbose <- FALSE
#'
#' # print some progress messages to stderr, if requested
#' if (opt$verbose) write("writing...", stderr())
#'
#' # do some operation based on user input
#' cat(rnorm(opt$count, mean = opt$mean, sd = opt$sd), sep = "\n")
getopt <- function(
	spec = NULL,
	opt = NULL,
	command = getfile(),
	usage = FALSE,
	debug = FALSE,
	operand = "after--only"
) {
	operand <- match.arg(operand, c("after--only", "strict"))
	if (usage) {
		return(getusage(spec, command))
	}

	# littler compatibility - map argv vector to opt
	if (is.null(opt)) {
		if (exists("argv", where = .GlobalEnv, inherits = FALSE)) {
			opt <- get("argv", envir = .GlobalEnv) # nocov
		} else {
			opt <- commandArgs(TRUE)
		}
	}

	dashdash <- match("--", opt, nomatch = NA_integer_)
	if (!is.na(dashdash)) {
		dashdash_operands <- opt[seq_len(length(opt) - dashdash) + dashdash]
		opt <- opt[seq_len(dashdash - 1L)]
		if (debug) {
			cat(
				"extracted positional args after `--`:",
				paste(dashdash_operands, collapse = " "),
				"\n"
			)
		}
	} else {
		dashdash_operands <- NULL
	}
	inline_operands <- NULL

	spec <- as_spec(spec)

	opt_normalized <- normalize_opt(opt, spec)
	if (debug && !identical(opt, opt_normalized)) {
		cat("normalized opt to:", paste(opt_normalized, collapse = " "), "\n")
	}
	opt <- opt_normalized

	result <- list()

	i <- 1L

	while (i <= length(opt)) {
		if (debug) {
			cat("processing", opt[i], "\n")
		}

		optstring <- opt[i]

		if (is_long_flag(optstring)) {
			if (debug) {
				cat("\tlong option:", optstring, "\n")
			}

			optstring <- substring(optstring, 3)
			if (grepl("=", optstring)) {
				kv <- strsplit(optstring, "=")[[1L]]
				this_flag <- kv[1L]
				this_argument <- paste(kv[-1L], collapse = "=")
			} else {
				this_flag <- optstring
				this_argument <- NA
			}

			rowmatch <- get_rowmatch(spec, long = this_flag)

			# if we have an argument embedded via '='
			if (!is.na(this_argument)) {
				long_name <- spec[rowmatch, COL_LONG_NAME]
				action <- spec[rowmatch, COL_ACTION]
				# if we can't accept the argument, bail out
				if (action %in% c("store_true", "store_false", "count")) {
					stop(paste0('long flag "', this_flag, '" accepts no arguments'))
				} else if (action == "append") {
					result[[long_name]] <- c(result[[long_name]], this_argument)
					i <- i + 1L
					next
				} else {
					result[[long_name]] <- this_argument
					i <- i + 1L
					next
				}
			}
		} else if (is_short_flag(optstring)) {
			if (debug) {
				cat("\tshort option:", optstring, "\n")
			}

			this_flag <- substring(optstring, 2L)
			rowmatch <- get_rowmatch(spec, short = this_flag)
		} else if (operand == "strict") {
			if (debug) {
				cat("collecting operand:", sQuote(optstring), "\n")
			}
			inline_operands <- c(inline_operands, optstring)
			i <- i + 1L
			next
		} else {
			stop(paste0('"', optstring, '" is not a valid option, or does not support an argument'))
		}

		long_name <- spec[rowmatch, COL_LONG_NAME]
		action <- spec[rowmatch, COL_ACTION]

		if (action == "count") {
			result[[long_name]] <- (result[[long_name]] %||% 0L) + 1L
			i <- i + 1L
			next
		} else if (action %in% c("store_true", "store_false")) {
			result[[long_name]] <- action != "store_false"
			i <- i + 1L
			next
		} else {
			# store or store_optional: peek ahead for argument
			if (debug) {
				if (action == "store") {
					cat("\t\trequires a argument\n")
				} else {
					cat("\t\toptionally takes an argument\n")
				}
			}
			if (length(opt) > i) {
				peek_optstring <- opt[i + 1L]
				if (debug) {
					cat("\t\t\tpeeking ahead at:", sQuote(peek_optstring), "\n")
				}

				if (
					!is_long_flag(peek_optstring) &&
						(is_negative_number(peek_optstring) || !is_short_flag(peek_optstring))
				) {
					if (debug) {
						cat("\t\t\t\tconsuming argument", sQuote(peek_optstring), "\n")
					}
					if (action == "append") {
						result[[long_name]] <- c(result[[long_name]], peek_optstring)
					} else {
						result[[long_name]] <- peek_optstring
					}
					i <- i + 2L
					next
				}
			} else if (debug) {
				cat("\t\t\tnothing ahead\n")
			}
			if (debug) {
				cat("\t\t\t\tno argument!\n")
			}
			if (action %in% c("store", "append")) {
				stop(paste0('flag `', this_flag, '` requires an argument'))
			} else {
				# action == "store_optional"
				result[[long_name]] <- TRUE
			}
		}
		i <- i + 1L
	}

	for (j in seq_len(nrow(spec))) {
		long_name <- spec[j, COL_LONG_NAME]
		if (is.character(result[[long_name]])) {
			mode <- spec[j, COL_MODE]
			val <- result[[long_name]]
			tryCatch(
				storage.mode(result[[long_name]]) <- mode,
				warning = function(w) {
					warning(paste(mode, "expected, got", dQuote(val)))
				}
			)
			if (any(is.na(result[[long_name]]) & !is.na(val))) {
				warning(paste(
					mode,
					"expected, got",
					paste(dQuote(val[is.na(result[[long_name]]) & !is.na(val)]), collapse = ", ")
				))
			}
		}
	}
	structure(result, class = "getopt", operand = c(inline_operands, dashdash_operands))
}

#' Extract positional arguments from a getopt result
#'
#' Extracts the positional arguments stored in the `"operands"` attribute of the
#' object returned by [getopt()].
#'
#' @param x An object of class `"getopt"` as returned by [getopt()].
#' @return A character vector of positional arguments.
#' @export
#' @examples
#' spec <- matrix(c("verbose", "v", 0, "logical"), ncol = 4, byrow = TRUE)
#' opt <- getopt(spec, c("--verbose", "--", "file1.txt", "file2.txt"))
#' getoperand(opt)
getoperand <- function(x) {
	stopifnot(inherits(x, "getopt"))
	attr(x, "operand")
}

#' Generate a usage string
#'
#' Generate a usage string from a getopt `spec` matrix.
#'
#' @inheritParams getopt
#' @param usage A template string for the usage line.  `"%command"` is replaced
#'   by the value of `command` and `"%options"` is replaced by the computed
#'   options string.
#' @return A character string with the usage message.
#' @export
#' @examples
#' spec <- matrix(c(
#'   'verbose', 'v', 2, "integer",
#'   'help'   , 'h', 0, "logical",
#'   'count'  , 'c', 1, "integer",
#'   'mean'   , 'm', 1, "double",
#'   'sd'     , 's', 1, "double"
#' ), byrow = TRUE, ncol = 4)
#' cat(getusage(spec, command = "myscript"))
#' cat(getusage(spec, command = "myscript",
#'              usage = "Usage: %command %options FILE"))
getusage <- function(spec, command = getfile(), usage = "Usage: %command %options") {
	spec <- as_spec(spec)

	options <- ""
	for (j in seq_len(nrow(spec))) {
		options <- paste0(
			options,
			" [-[-",
			spec[j, COL_LONG_NAME],
			"|",
			spec[j, COL_SHORT_NAME],
			"]"
		)
		if (spec[j, COL_ACTION] %in% c("store_true", "store_false", "count")) {
			options <- paste0(options, "]")
		} else if (spec[j, COL_ACTION] %in% c("store", "append")) {
			options <- paste0(options, " <", spec[j, COL_MODE], ">]")
		} else if (spec[j, COL_ACTION] == "store_optional") {
			options <- paste0(options, " [<", spec[j, COL_MODE], ">]]")
		}
	}
	options <- trimws(options)
	usage <- gsub("%command", format(command), usage, fixed = TRUE)
	usage <- gsub("%options", options, usage, fixed = TRUE)
	ret <- paste0(usage, "\n")
	# include usage strings
	if (ncol(spec) >= 5L) {
		max.long <- max(nchar(spec[, COL_LONG_NAME]))
		for (j in seq_len(nrow(spec))) {
			ret <- paste0(
				ret,
				sprintf(
					paste0("    -%s|--%-", max.long, "s    %s\n"),
					spec[j, COL_SHORT_NAME],
					spec[j, COL_LONG_NAME],
					spec[j, COL_DESCRIPTION]
				)
			)
		}
	}
	ret
}

as_spec <- function(spec) {
	if (is.data.frame(spec)) {
		spec <- as.matrix(spec)
	} else if (is.vector(spec) && is.character(spec) && length(spec) %% 4L == 0L) {
		warning(
			'argument "spec" was coerced to a 4-column (row-major) matrix.  use a matrix to prevent the coercion'
		)
		spec <- matrix(spec, ncol = 4L, byrow = TRUE)
	} else if (!is.matrix(spec)) {
		stop(
			'argument "spec" must be a matrix, data frame, or character vector with length divisible by 4.'
		)
	}

	if (ncol(spec) < 4L) {
		stop('"spec" should have at least 4 columns.')
	} else if (ncol(spec) > 6L) {
		stop('"spec" should have no more than 6 columns.')
	}

	# sanity check.  make sure long names are unique, and short names are unique.
	if (anyDuplicated(spec[, COL_LONG_NAME])) {
		stop(paste0("redundant long names for flags (column ", COL_LONG_NAME, " of spec matrix)."))
	}
	if (anyDuplicated(na_omit(spec[, COL_SHORT_NAME]))) {
		stop(paste0(
			"redundant short names for flags (column ",
			COL_SHORT_NAME,
			" of spec matrix)."
		))
	}

	# normalize legacy numeric action values to action strings
	spec[, COL_ACTION] <- gsub("0", "store_true", spec[, COL_ACTION], fixed = TRUE)
	spec[, COL_ACTION] <- gsub("1", "store", spec[, COL_ACTION], fixed = TRUE)
	spec[, COL_ACTION] <- gsub("2", "store_optional", spec[, COL_ACTION], fixed = TRUE)

	valid_actions <- c("append", "count", "store", "store_false", "store_optional", "store_true")
	bad_actions <- setdiff(spec[, COL_ACTION], valid_actions)
	if (length(bad_actions) > 0L) {
		stop(paste0(
			'column ',
			COL_ACTION,
			' of "spec" contains invalid action(s): ',
			paste(dQuote(bad_actions), collapse = ", "),
			'.  Valid actions: ',
			paste(dQuote(valid_actions), collapse = ", "),
			"."
		))
	}

	# convert numeric type to double type
	spec[, COL_MODE] <- gsub("numeric", "double", spec[, COL_MODE], fixed = TRUE)

	valid_modes <- c("character", "complex", "double", "integer", "logical")
	bad_modes <- setdiff(spec[, COL_MODE], valid_modes)
	if (length(bad_modes) > 0L) {
		stop(paste0(
			'column ',
			COL_MODE,
			' of "spec" contains invalid mode(s): ',
			paste(dQuote(bad_modes), collapse = ", "),
			'.  Valid modes: ',
			paste(dQuote(valid_modes), collapse = ", "),
			"."
		))
	}

	spec
}

test_that("getopt works as expected", {
	# fmt: skip
	spec <- matrix(c(
		"verbose", "v", 2, "integer",
		"help"   , "h", 0, "logical",
		"dummy1" , "d", 0, "logical",
		"dummy2" , "e", 2, "logical",
		"count"  , "c", 1, "integer",
		"mean"   , "m", 1, "double",
		"sd"     , "s", 1, "double",
		"output" , "O", 1, "character"
	), ncol = 4, byrow = TRUE)
	expect_equal(
		sort_list(getopt(spec, c("-c", "-1", "-m", "-1.2"))),
		sort_list(list(count = -1, mean = -1.2))
	)
	expect_equal(
		sort_list(getopt(spec, c("-v", "-m", "3"))),
		sort_list(list(verbose = TRUE, mean = 3))
	)
	expect_equal(
		sort_list(getopt(spec, c("-m", "3", "-v"))),
		sort_list(list(mean = 3, verbose = TRUE))
	)
	expect_equal(
		sort_list(getopt(spec, c("-m", "3", "-v", "2", "-v"))),
		sort_list(list(mean = 3, verbose = TRUE))
	)
	expect_equal(
		sort_list(getopt(spec, c("-O", "-", "-m", "3"))),
		sort_list(list(output = "-", mean = 3))
	)
	expect_equal(
		sort_list(getopt(spec, c("-O", "-", "-m", "3"))),
		sort_list(getopt(spec, c("-m", "3", "-O", "-")))
	)
	expect_equal(sort_list(getopt(spec, c("-de"))), sort_list(getopt(spec, c("-ed"))))
	expect_equal(
		sort_list(getopt(spec, c("-de"))),
		sort_list(list(dummy1 = TRUE, dummy2 = TRUE))
	)
	expect_warning(
		expect_equal(
			sort_list(getopt(spec, c("-de", "1"))),
			sort_list(list(dummy1 = TRUE, dummy2 = NA))
		)
	)
	expect_equal(
		sort_list(getopt(spec, c("--verbose"))),
		sort_list(list(verbose = TRUE))
	)
	expect_equal(
		sort_list(getopt(spec, c("--verbose", "1", "--help"))),
		sort_list(list(verbose = 1L, help = TRUE))
	)
	expect_equal(
		sort_list(getopt(spec, c("--verbose", "--mean", "5"))),
		sort_list(list(verbose = TRUE, mean = 5))
	)
	expect_equal(
		sort_list(getopt(spec, c("--mean=5"))),
		sort_list(list(mean = 5))
	)
	expect_equal(
		sort_list(getopt(spec, c("--verbose", "--mean=5", "--sd", "5"))),
		sort_list(list(verbose = TRUE, mean = 5, sd = 5))
	)
	expect_equal(
		sort_list(getopt(spec, c("--verbose", "--mean=5", "--sd", "5"))),
		sort_list(getopt(spec, c("--mean=5", "--sd", "5", "--verbose")))
	)

	# fmt: skip
	spec <- c(
		"date"     , "d", 1, "character",
		"help"     , "h", 0, "logical",
		"getdata"  , "g", 0, "logical",
		"market"   , "m", 1, "character",
		"threshold", "t", 1, "double"
	)
	spec2 <- matrix(spec, ncol = 4, byrow = TRUE)
	# should give warning is spec is not matrix
	expect_warning(getopt(spec, c("--date", "20080421", "--market", "YM", "--getdata")))
	expect_equal(
		sort_list(getopt(spec2, c("--date", "20080421", "--market", "YM", "--getdata"))),
		sort_list(list(date = "20080421", market = "YM", getdata = TRUE))
	)
	expect_equal(
		sort_list(getopt(spec2, c("--date", "20080421", "--market", "YM", "--getdata"))),
		sort_list(getopt(spec2, c("--date", "20080421", "--getdata", "--market", "YM")))
	)
	expect_snapshot(cat(getopt(spec2, usage = TRUE)))
})
test_that("numeric is cast to double", {
	# Feature reported upstream (optparse) by Miroslav Posta
	spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
	opt <- getopt(spec, c("-c", "-55"))
	expect_equal(typeof(opt$count), "integer")

	spec <- matrix(c("count", "c", 1, "numeric"), ncol = 4, byrow = TRUE)
	opt <- getopt(spec, c("-c", "-55.0"))
	expect_equal(typeof(opt$count), "double")
})
test_that("action strings work as alternatives to 0/1/2", {
	# fmt: skip
	spec <- matrix(c(
		"foo", "f", "store_true"    , "logical",
		"bar", "b", "store"         , "character",
		"biz", "z", "store_optional", "logical"
	), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, "-f")$foo, TRUE)
	expect_equal(getopt(spec, c("-b", "hello"))$bar, "hello")
	expect_equal(getopt(spec, "-z")$biz, TRUE)
})
test_that("store_false stores FALSE", {
	spec <- matrix(c("verbose", "v", "store_false", "logical"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, "-v")$verbose, FALSE)
	expect_equal(getopt(spec, "--verbose")$verbose, FALSE)
})
test_that("count increments each time flag is used", {
	spec <- matrix(c("verbose", "v", "count", "integer"), ncol = 4, byrow = TRUE)
	expect_null(getopt(spec, character(0))$verbose)
	expect_equal(getopt(spec, "-v")$verbose, 1L)
	expect_equal(getopt(spec, c("-v", "-v", "-v"))$verbose, 3L)
	expect_equal(getopt(spec, "--verbose")$verbose, 1L)
	expect_equal(getopt(spec, c("--verbose", "--verbose"))$verbose, 2L)
})
test_that("append collects repeated flag values into a vector", {
	spec <- matrix(c("path", "p", "append", "character"), ncol = 4, byrow = TRUE)
	expect_null(getopt(spec, character(0))$path)
	expect_equal(getopt(spec, c("-p", "foo"))$path, "foo")
	expect_equal(getopt(spec, c("-p", "foo", "-p", "bar"))$path, c("foo", "bar"))
	expect_equal(getopt(spec, c("--path", "foo", "--path", "bar"))$path, c("foo", "bar"))
	expect_equal(getopt(spec, c("--path=foo", "--path=bar"))$path, c("foo", "bar"))
	expect_snapshot(error = TRUE, getopt(spec, "-p"))
})
test_that("-- separator puts remaining args in getoperand()", {
	spec <- matrix(c("verbose", "v", 0, "logical"), ncol = 4, byrow = TRUE)
	opt <- getopt(spec, c("--verbose", "--", "file1.txt", "file2.txt"))
	expect_true(opt$verbose)
	expect_equal(getoperand(opt), c("file1.txt", "file2.txt"))

	opt <- getopt(spec, c("--verbose", "--"))
	expect_equal(getoperand(opt), character(0))

	opt <- getopt(spec, c("--verbose"))
	expect_null(getoperand(opt))
})
test_that("operand = 'strict' collects non-flag tokens as operands", {
	# fmt: skip
	spec <- matrix(c(
		"verbose", "v", 0, "logical",
		"mean"   , "m", 1, "double"
	), ncol = 4, byrow = TRUE)
	opt <- getopt(spec, c("--verbose", "file1.txt", "--mean", "3", "file2.txt"), operand = "strict")
	expect_true(opt$verbose)
	expect_equal(opt$mean, 3)
	expect_equal(getoperand(opt), c("file1.txt", "file2.txt"))

	# unrecognized flags still error
	expect_snapshot(
		error = TRUE,
		getopt(spec, c("--unknown"), operand = "strict")
	)
	# after-- operands are also included
	opt <- getopt(spec, c("file1.txt", "--", "file2.txt"), operand = "strict")
	expect_equal(getoperand(opt), c("file1.txt", "file2.txt"))
})
test_that("data.frame spec is coerced to matrix", {
	spec <- as.data.frame(matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE))
	expect_equal(getopt(spec, c("-c", "5"))$count, 5L)
})
test_that("empty strings are handled correctly for mandatory character arguments", {
	# fmt: skip
	spec <- matrix(c(
		"string", "s", 1, "character",
		"number", "9", 1, "numeric"
	), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("--string=foo"))$string, "foo")
	expect_equal(getopt(spec, c("--string="))$string, "")
	expect_equal(getopt(spec, c("-9", "-4"))$number, -4)
	expect_warning(getopt(spec, c("--number=")))
})

test_that("negative numbers are handled correctly", {
	# Issue if negative number preceded by space instead of '=' reported by Roman Zenka
	spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("-c", "5"))$count, 5)
	spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("-c", "-5"))$count, -5)
	spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("--count=-1E5"))$count, -1E5)
	spec <- matrix(c("count", "c", 1, "double"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("-c", "-5"))$count, -5)
	spec <- matrix(c("count", "c", 1, "double"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("-c", "-1e5"))$count, -1e5)
	spec <- matrix(c("count", "c", 1, "double"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("--count=-1.2e5"))$count, -1.2e5)
	spec <- matrix(c("count", "c", 1, "double"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("--count", "-1e5"))$count, -1e5)
})

test_that("more helpful warnings upon incorrect input", {
	# Give more pointed warning upon wildly incorrect input
	expect_snapshot({
		spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
		getopt(spec, c("-c", "hello"))$count
	})

	expect_snapshot(
		{
			spec <- NULL
			getopt(spec, "")

			spec <- c("foo", "f", 0)
			getopt(spec, "")

			spec <- matrix(c("foo", "f", 0, "integer"), ncol = 2)
			getopt(spec, "")

			spec <- matrix(c("foo", "f", 0, "integer", "bar", "b", 0, "integer"), ncol = 8)
			getopt(spec, "")

			spec <- matrix(c("foo", "f", "store_sideways", "logical"), ncol = 4, byrow = TRUE)
			getopt(spec, "")

			spec <- matrix(c("foo", "f", 0, "bignum"), ncol = 4, byrow = TRUE)
			getopt(spec, "")
		},
		error = TRUE
	)
})

test_that("don't throw error if multiple matches match one argument fully", {
	# test if partial name matches fully,
	# still throw error if multiple matches and doesn't match both fully
	# feature request from Jonas Zimmermann
	# fmt: skip
	spec <- matrix(c(
		"foo"   , "f", 0, "logical",
		"foobar", "b", 0, "logical",
		"biz"   , "z", 0, "logical"
	), ncol = 4, byrow = TRUE)
	expect_error(getopt(spec, c("--fo")))
	expect_equal(getopt(spec, c("--foo")), sort_list(list(foo = TRUE)), ignore_attr = TRUE)
})

test_that("sort_list works as expected", {
	expect_equal(sort_list(list(a = 3, b = 2)), sort_list(list(b = 2, a = 3)))
	expect_false(identical(sort_list(list(b = 3, a = 2)), list(b = 3, a = 2)))
	expect_false(identical(
		sort_list(list(b = list(b = 3, c = 2), a = 2)),
		list(b = list(c = 2, b = 3), a = 2)
	))
})

test_that("Use h flag for non help", {
	spec <- matrix(c("foo", "h", 0, "logical"), ncol = 4, byrow = TRUE)
	expect_equal(getopt(spec, c("-h")), sort_list(list(foo = TRUE)), ignore_attr = TRUE)

	spec <- matrix(c("foo", "h", 0, "logical", "help", "h", 0, "logical"), ncol = 4, byrow = TRUE)
	expect_error(getopt(spec, c("-h")), "redundant short names for flags")

	spec <- matrix(c("foo", "f", 0, "logical", "foo", "h", 0, "logical"), ncol = 4, byrow = TRUE)
	expect_error(getopt(spec, c("-h")), "redundant long names for flags")
})

test_that("Optional usage strings work as expected", {
	# fmt: skip
	spec <- matrix(c(
		"foo"   , "f", 0, "logical"  , "foo usage",
		"foobar", "b", 1, "character", "foobar usage",
		"biz"   , "z", 2, "logical"  , "biz usage",
		"number", "n", 1, "numeric"  , "number usage",
		"help"  , "h", 0, "logical"  , "help"
	), ncol = 5, byrow = TRUE)
	expect_snapshot(cat(getopt(spec, usage = TRUE)))
})

test_that("tests to get coverage up", {
	# fmt: skip
	spec <- matrix(c(
		"foo"   , "f", 0, "logical"  , "foo usage",
		"foobar", "b", 1, "character", "foobar usage",
		"biz"   , "z", 2, "logical"  , "biz usage",
		"number", "n", 1, "numeric"  , "number usage",
		"help"  , "h", 0, "logical"  , "help"
	), ncol = 5, byrow = TRUE)
	expect_error(getopt(spec, "--whodunit"), 'long flag "whodunit" is invalid')

	expect_error(getopt(spec, "--foo=4"), 'long flag "foo" accepts no arguments')

	# expect_error(getopt(spec, c("--foo", "4")), 'long flag "foo" accepts no arguments') # nolint

	expect_equal(getopt(spec, "--biz", "4"), sort_list(list(biz = TRUE)), ignore_attr = TRUE)

	expect_warning(getopt(spec, c("-n", "bar")), paste("double expected, got", dQuote("bar")))

	expect_warning(getopt(spec, c("--number=bar")), paste("double expected, got", dQuote("bar")))

	expect_error(getopt(spec, "-n"), 'flag `n` requires an argument')

	expect_error(getopt(spec, "-p"), 'short flag "p" is invalid')

	expect_error(getopt(spec, "-nh"), 'flag `n` requires an argument')
	expect_error(getopt(spec, "-fn"), 'flag `n` requires an argument')

	expect_error(
		getopt(spec, c("--number", 3, 4)),
		'"4" is not a valid option, or does not support an argument'
	)
	expect_error(getopt(spec, c("-b")), 'flag `b` requires an argument')
	expect_error(getopt(spec, c("--foobar")), 'flag `foobar` requires an argument')
	expect_error(getopt(spec, c("--foobar", "--help")), 'flag `foobar` requires an argument')

	expect_warning(getopt(spec, c("-n", "-")), paste("double expected, got", dQuote("-")))
})
test_that("debug output", {
	spec <- matrix(
		c("foo", "f", 0L, "logical", "bar", "b", 1L, "character", "num", "n", 2L, "double"),
		ncol = 4L,
		byrow = TRUE
	)
	expect_snapshot(. <- getopt(spec, c("--foo", "--bar", "baz"), debug = TRUE))
	expect_snapshot(. <- getopt(spec, c("-fn", "2"), debug = TRUE))
	expect_snapshot(. <- getopt(spec, c("-b", "-"), debug = TRUE))
	expect_snapshot(. <- getopt(spec, c("--foo", "--", "file1.txt", "file2.txt"), debug = TRUE))
})

# getopt works as expected

    Code
      cat(getopt(spec2, usage = TRUE))
    Output
      Usage: NA [-[-date|d] <character>] [-[-help|h]] [-[-getdata|g]] [-[-market|m] <character>] [-[-threshold|t] <double>]

# append collects repeated flag values into a vector

    Code
      getopt(spec, "-p")
    Condition
      Error in `getopt()`:
      ! flag `p` requires an argument

# operand = 'strict' collects non-flag tokens as operands

    Code
      getopt(spec, c("--unknown"), operand = "strict")
    Condition
      Error in `get_rowmatch()`:
      ! long flag "unknown" is invalid

# more helpful warnings upon incorrect input

    Code
      spec <- matrix(c("count", "c", 1, "integer"), ncol = 4, byrow = TRUE)
      getopt(spec, c("-c", "hello"))$count
    Condition
      Warning in `value[[3L]]()`:
      integer expected, got "hello"
    Output
      [1] "hello"

---

    Code
      spec <- NULL
      getopt(spec, "")
    Condition
      Error in `as_spec()`:
      ! argument "spec" must be a matrix, data frame, or character vector with length divisible by 4.
    Code
      spec <- c("foo", "f", 0)
      getopt(spec, "")
    Condition
      Error in `as_spec()`:
      ! argument "spec" must be a matrix, data frame, or character vector with length divisible by 4.
    Code
      spec <- matrix(c("foo", "f", 0, "integer"), ncol = 2)
      getopt(spec, "")
    Condition
      Error in `as_spec()`:
      ! "spec" should have at least 4 columns.
    Code
      spec <- matrix(c("foo", "f", 0, "integer", "bar", "b", 0, "integer"), ncol = 8)
      getopt(spec, "")
    Condition
      Error in `as_spec()`:
      ! "spec" should have no more than 6 columns.
    Code
      spec <- matrix(c("foo", "f", "store_sideways", "logical"), ncol = 4, byrow = TRUE)
      getopt(spec, "")
    Condition
      Error in `as_spec()`:
      ! column 3 of "spec" contains invalid action(s): "store_sideways".  Valid actions: "append", "count", "store", "store_false", "store_optional", "store_true".
    Code
      spec <- matrix(c("foo", "f", 0, "bignum"), ncol = 4, byrow = TRUE)
      getopt(spec, "")
    Condition
      Error in `as_spec()`:
      ! column 4 of "spec" contains invalid mode(s): "bignum".  Valid modes: "character", "complex", "double", "integer", "logical".

# Optional usage strings work as expected

    Code
      cat(getopt(spec, usage = TRUE))
    Output
      Usage: NA [-[-foo|f]] [-[-foobar|b] <character>] [-[-biz|z] [<logical>]] [-[-number|n] <double>] [-[-help|h]]
          -f|--foo       foo usage
          -b|--foobar    foobar usage
          -z|--biz       biz usage
          -n|--number    number usage
          -h|--help      help

# debug output

    Code
      . <- getopt(spec, c("--foo", "--bar", "baz"), debug = TRUE)
    Output
      processing --foo 
      	long option: --foo 
      processing --bar 
      	long option: --bar 
      		requires a argument
      			peeking ahead at: 'baz' 
      				consuming argument 'baz' 

---

    Code
      . <- getopt(spec, c("-fn", "2"), debug = TRUE)
    Output
      normalized opt to: -f -n 2 
      processing -f 
      	short option: -f 
      processing -n 
      	short option: -n 
      		optionally takes an argument
      			peeking ahead at: '2' 
      				consuming argument '2' 

---

    Code
      . <- getopt(spec, c("-b", "-"), debug = TRUE)
    Output
      processing -b 
      	short option: -b 
      		requires a argument
      			peeking ahead at: '-' 
      				consuming argument '-' 

---

    Code
      . <- getopt(spec, c("--foo", "--", "file1.txt", "file2.txt"), debug = TRUE)
    Output
      extracted positional args after `--`: file1.txt file2.txt 
      processing --foo 
      	long option: --foo 

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getopt.R
\name{getoperand}
\alias{getoperand}
\title{Extract positional arguments from a getopt result}
\usage{
getoperand(x)
}
\arguments{
\item{x}{An object of class \code{"getopt"} as returned by \code{\link[=getopt]{getopt()}}.}
}
\value{
A character vector of positional arguments.
}
\description{
Extracts the positional arguments stored in the \code{"operands"} attribute of the
object returned by \code{\link[=getopt]{getopt()}}.
}
\examples{
spec <- matrix(c("verbose", "v", 0, "logical"), ncol = 4, byrow = TRUE)
opt <- getopt(spec, c("--verbose", "--", "file1.txt", "file2.txt"))
getoperand(opt)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{getfile}
\alias{getfile}
\alias{get_Rscript_filename}
\title{Returns file name being interpreted by Rscript}
\usage{
getfile()

get_Rscript_filename()
}
\value{
A string with the filename of the calling script.
If not found (i.e. you are in a interactive session) returns \code{NA_character_}.
}
\description{
\code{getfile()} returns the file name that \code{Rscript} is interpreting.
Also supports \code{littler} via the \code{LITTLER_SCRIPT_PATH} environment variable.
\code{get_Rscript_filename()} is an alias.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getopt.R
\name{getopt}
\alias{getopt}
\alias{getopt-package}
\title{C-like getopt behavior}
\usage{
getopt(
  spec = NULL,
  opt = NULL,
  command = getfile(),
  usage = FALSE,
  debug = FALSE,
  operand = "after--only"
)
}
\arguments{
\item{spec}{The getopt specification, or spec of what options are considered
valid.  The specification must be either a 4-5 column matrix, a 4-5 column data frame, or a
character vector coercible into a 4 column matrix using
\code{matrix(x, ncol = 4L, byrow = TRUE)} command.  The matrix/vector
contains:

Column 1: the \emph{long flag} name.  A multi-character string.

Column 2: \emph{short flag} alias of Column 1.  A single-character string.
May be \code{NA_character_} if there is no short flag.

Column 3: \emph{Action} of the \emph{flag}.  A string.
Possible values:
\itemize{
\item \code{"append"} (flag takes a required argument; appends it to a vector each time the flag is used)
\item \code{"count"} (flag takes no argument; stores count of how many times the flag was present)
\item \code{"store_true"} (flag takes no argument; stores \code{TRUE})
\item \code{"store_false"} (flag takes no argument; stores \code{FALSE})
\item \code{"store"} (flag takes a required argument)
\item \code{"store_optional"} (flag takes an optional argument but if none present stores \code{TRUE})
}

For backwards compatibility \code{0}, \code{1}, \code{2} are accepted as aliases for
\code{"store_true"}, \code{"store"}, \code{"store_optional"} respectively.

Column 4: Data type to which the \emph{flag}'s argument shall be cast using
\code{\link[=storage.mode]{storage.mode()}}.  A multi-character string.
Only used when an action took an argument.
Possible values: "logical", "integer", "double", "complex", "character".
"numeric" is treated as an alias for "double".

Column 5 (optional): A brief description of the purpose of the option.

The terms \emph{option}, \emph{flag}, \emph{long flag}, \emph{short flag},
and \emph{argument} have very specific meanings in the context of this
document.  Read the \dQuote{Details} section of \code{\link[=getopt]{getopt()}} for definitions.}

\item{opt}{This defaults to the return value of \code{commandArgs(TRUE)} unless
\code{argv} is in the global environment in which case it uses that instead
(this is for compatibility with \code{littler}).

If R was invoked directly via the \code{R} command, this corresponds to all
arguments passed to R after the \code{--args} flag.

If R was invoked via the \code{Rscript} command, this corresponds to all
arguments after the name of the R script file.

Read about \code{\link[=commandArgs]{commandArgs()}} and \link{Rscript} to learn more.}

\item{command}{The string to use in the usage message as the name of the
script.  See argument \emph{usage}.}

\item{usage}{If \code{TRUE}, argument \code{opt} will be ignored and a usage
statement (character string) will be generated and returned from \code{spec}.}

\item{debug}{This is used internally to debug the \code{getopt()} function itself.}

\item{operand}{Controls how positional arguments (operands) are handled.
\itemize{
\item \code{"after--only"} (the default) only collects operands that appear after a \code{"--"} separator.
\item \code{"strict"} (in addition to operands that appear after a \code{"--"} separator) collects tokens that do not look
like flags and were not consumed as a flag argument, while still erroring on
unrecognized flags.
}

Operands are stored in the \code{"operand"} attribute of the
result and can be retrieved with \code{\link[=getoperand]{getoperand()}}.}
}
\value{
\code{\link[=getopt]{getopt()}} returns a list data structure containing names of the
flags that were present in the character vector passed in under
the \code{opt} argument.  Each value of the list is coerced to the
data type specified according to the value of the \code{spec} argument.  See
the \dQuote{Details} section for more information.
Any positional arguments (operands) are stored in its \code{"operand"} attribute
and can also be accessed by \code{\link[=getoperand]{getoperand()}}.
}
\description{
\code{getopt} is primarily intended to be used with \code{Rscript}.  It
facilitates writing \verb{#!} shebang scripts that accept short and long
flags/options.  It can also be used from \code{R} directly, but is probably less
useful in this context.
}
\details{
Notes on naming convention:
\enumerate{
\item An \emph{option} is one of the shell-split input strings.
\item A \emph{flag} is a type of \emph{option}.  a \emph{flag} can be defined as
having no \emph{argument} (defined below), a required \emph{argument}, or an
optional \emph{argument}.
\item An \emph{argument} is a type of \emph{option}, and is the value associated
with a flag.
\item A \emph{long flag} is a type of \emph{flag}, and begins with the string
\verb{--}.  If the \emph{long flag} has an associated \emph{argument}, it may be
delimited from the \emph{long flag} by either a trailing \code{=}, or may be
the subsequent \emph{option}.
\item A \emph{short flag} is a type of \emph{flag}, and begins with the string
\code{-}.  If a \emph{short flag} has an associated \emph{argument}, it is the
subsequent \emph{option}.  \emph{short flags} may be bundled together,
sharing a single leading \code{-}, but only the final \emph{short flag} is able
to have a corresponding \emph{argument}.
}

Many users wonder whether they should use the \code{getopt} package, \code{optparse} package,
or \code{argparse} package.
Here is some of the major differences:

Features available in \code{getopt} unavailable in \code{optparse}
\enumerate{
\item \code{getopt} allows one to specify options with an optional argument.
\item Long flags may be abbreviated as long as the abbreviation is unique,
e.g. \code{--verb} matches \code{--verbose} if no other long flag starts with \code{verb}.
}

Some features implemented in the \code{optparse} package unavailable in \code{getopt}
\enumerate{
\item Support for capturing positional arguments after the optional arguments
when \code{positional_arguments} set to \code{TRUE} in \code{optparse::parse_args()}
\item Automatic generation of an help option and printing of help text when encounters an \code{-h}
\item Option to specify default arguments for options as well the
variable name to store option values
}

There is also package \code{argparse} supports
all the features of both getopt and optparse (plus more)

Some Features unlikely to be implemented in \code{getopt}:
\enumerate{
\item Support for lists, e.g. \verb{--define os=linux --define os=redhat} would
set \code{result$os$linux=TRUE} and \code{result$os$redhat=TRUE}.
}
}
\examples{
#!/path/to/Rscript
library('getopt')
# get options, using the spec as defined by the matrix
spec <- matrix(c(
  'verbose', 'v', 2, "integer",
  'help'   , 'h', 0, "logical",
  'count'  , 'c', 1, "integer",
  'mean'   , 'm', 1, "double",
  'sd'     , 's', 1, "double"
), byrow = TRUE, ncol = 4L)
opt <- getopt(spec)

# if help was asked for print a friendly message and exit
if (isTRUE(opt$help)) {
  cat(getusage(spec))
  q(status = 0)
}

# set reasonable defaults for options that were not specified
if (is.null(opt$mean)) opt$mean <- 0
if (is.null(opt$sd)) opt$sd <- 1
if (is.null(opt$count)) opt$count <- 10L
if (is.null(opt$verbose)) opt$verbose <- FALSE

# print some progress messages to stderr, if requested
if (opt$verbose) write("writing...", stderr())

# do some operation based on user input
cat(rnorm(opt$count, mean = opt$mean, sd = opt$sd), sep = "\n")
}
\author{
Allen Day and Trevor L. Davis
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{get_Rscript_filename}
\alias{get_Rscript_filename}
\title{Returns file name being interpreted by Rscript}
\usage{
get_Rscript_filename()
}
\value{
A string with the filename of the calling script.
If not found (i.e. you are in a interactive session) returns \code{NA_character_}.
}
\description{
\code{get_Rscript_filename()} returns the file name that \code{Rscript} is interpreting.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{sort_list}
\alias{sort_list}
\title{Recursively sorts a list}
\usage{
sort_list(unsorted_list)
}
\arguments{
\item{unsorted_list}{A list.}
}
\value{
A sorted list.
}
\description{
\code{sort_list()} returns a recursively sorted list
}
\examples{
l <- list(b = 2, a = 1)
sort_list(l)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getopt.R
\name{getusage}
\alias{getusage}
\title{Generate a usage string}
\usage{
getusage(spec, command = getfile(), usage = "Usage: \%command \%options")
}
\arguments{
\item{spec}{The getopt specification, or spec of what options are considered
valid.  The specification must be either a 4-5 column matrix, a 4-5 column data frame, or a
character vector coercible into a 4 column matrix using
\code{matrix(x, ncol = 4L, byrow = TRUE)} command.  The matrix/vector
contains:

Column 1: the \emph{long flag} name.  A multi-character string.

Column 2: \emph{short flag} alias of Column 1.  A single-character string.
May be \code{NA_character_} if there is no short flag.

Column 3: \emph{Action} of the \emph{flag}.  A string.
Possible values:
\itemize{
\item \code{"append"} (flag takes a required argument; appends it to a vector each time the flag is used)
\item \code{"count"} (flag takes no argument; stores count of how many times the flag was present)
\item \code{"store_true"} (flag takes no argument; stores \code{TRUE})
\item \code{"store_false"} (flag takes no argument; stores \code{FALSE})
\item \code{"store"} (flag takes a required argument)
\item \code{"store_optional"} (flag takes an optional argument but if none present stores \code{TRUE})
}

For backwards compatibility \code{0}, \code{1}, \code{2} are accepted as aliases for
\code{"store_true"}, \code{"store"}, \code{"store_optional"} respectively.

Column 4: Data type to which the \emph{flag}'s argument shall be cast using
\code{\link[=storage.mode]{storage.mode()}}.  A multi-character string.
Only used when an action took an argument.
Possible values: "logical", "integer", "double", "complex", "character".
"numeric" is treated as an alias for "double".

Column 5 (optional): A brief description of the purpose of the option.

The terms \emph{option}, \emph{flag}, \emph{long flag}, \emph{short flag},
and \emph{argument} have very specific meanings in the context of this
document.  Read the \dQuote{Details} section of \code{\link[=getopt]{getopt()}} for definitions.}

\item{command}{The string to use in the usage message as the name of the
script.  See argument \emph{usage}.}

\item{usage}{A template string for the usage line.  \code{"\%command"} is replaced
by the value of \code{command} and \code{"\%options"} is replaced by the computed
options string.}
}
\value{
A character string with the usage message.
}
\description{
Generate a usage string from a getopt \code{spec} matrix.
}
\examples{
spec <- matrix(c(
  'verbose', 'v', 2, "integer",
  'help'   , 'h', 0, "logical",
  'count'  , 'c', 1, "integer",
  'mean'   , 'm', 1, "double",
  'sd'     , 's', 1, "double"
), byrow = TRUE, ncol = 4)
cat(getusage(spec, command = "myscript"))
cat(getusage(spec, command = "myscript",
             usage = "Usage: \%command \%options FILE"))
}
